
%include "nasm.h"

[segment_code]

;***************************************************************

proc	entry_3DN

		%$coeff			arg		4
		%$in_vector		arg		4
		%$out_vector	arg		4
		%$count			arg		4

		femms
		pushd	ebp, edi, esi, ebx

		mov		r0, [sp(%$in_vector)]
		add		r0, fsizen(18)
		add		dword [sp(%$coeff)], fsizen(18)
		pmov	mm6, [r0+ fsize*2 -fsizen(18)]

		align 32
.lp3:
		mov		r5, fsizen(36)
		mov		r3, [sp(%$coeff)]
		mov		r2, fsizen(36*2)
		mov		r1, [sp(%$out_vector)]
		mov		r4, 18/3
		add		r5, r3
		add		r2, r3
		pxor	mm0, mm0

		align 32
.lp2:
		pmov	mm4, [r3+ fsizen(0) -fsizen(18)]
		pmov	mm1, mm0

		pmov	mm3, [r0+ fsizen(0) -fsizen(18)]
		pmov	mm2, mm0

		pmov	mm5, [r5+ fsizen(0) -fsizen(18)]
		pfmul	mm4, mm3

		pmov	mm7, mm6
		pfmul	mm5, mm3
		pfadd	mm0, mm4

		pfmul	mm3, [r2+ fsizen(0) -fsizen(18)]
		pfadd	mm1, mm5
		pmov	mm4, [r3+ fsizen(2) -fsizen(18)]
		pfadd	mm2, mm3

%macro pfmov_mul 3
		pmov	mm5 , [r5+ fsizen(%3)   -fsizen(18)]
		pfmul	mm4 , mm%1
		pmov	mm%2, [r0+ fsizen(%3+2) -fsizen(18)]
		pfmul	mm5 , mm%1
		pfadd	mm0 , mm4
		pfmul	mm%1, [r2+ fsizen(%3)   -fsizen(18)]
		pfadd	mm1 , mm5
		pmov	mm4 , [r3+ fsizen(%3+2) -fsizen(18)]
		pfadd	mm2 , mm%1
%endmacro

		pfmov_mul 7, 3, 2
		pfmov_mul 3, 7, 4
		pfmov_mul 7, 3, 6
		pfmov_mul 3, 7, 8
		pfmov_mul 7, 3, 10
		pfmov_mul 3, 7, 12
		pfmov_mul 7, 3, 14
		pfmov_mul 3, 7, 16
		pfmov_mul 7, 3, 18
		pfmov_mul 3, 7, 20
		pfmov_mul 7, 3, 22
		pfmov_mul 3, 7, 24
		pfmov_mul 7, 3, 26
		pfmov_mul 3, 7, 28
		pfmov_mul 7, 3, 30
		pfmov_mul 3, 7, 32

		pfmul	mm4, mm7
		pmov	mm5, [r5+ fsizen(34) -fsizen(18)]
		pfmul	mm5, mm7
		pfadd	mm0, mm4
		add		r1, fsizen(3)
		add		r3, fsizen(36*3)
		pfadd	mm1, mm5
		pfmul	mm7, [r2+ fsizen(34) -fsizen(18)]
		add		r5, fsizen(36*3)
		add		r2, fsizen(36*3)
		pfadd	mm2, mm7
		pfacc	mm0, mm1
		dec		r4
		pfacc	mm2, mm2
		pmov	[r1-fsizen(3)], mm0
		pxor	mm0, mm0
		movd	[r1-fsize], mm2
		jnz	near .lp2

		dec		dword [sp(%$count)]
		jnz	near .lp3
		
		femms
		popd	ebp, edi, esi, ebx
endproc

;***************************************************************

proc	entry_3DN_SOA

		%$coeff			arg		4
		%$in_vector		arg		4
		%$out_vector	arg		4
		%$count			arg		4

		femms
		pushd	ebp, edi, esi, ebx

		align 32
.lp_count:
		mov			r3, [sp(%$in_vector)]
		mov			r1, [sp(%$coeff)]
		mov			r0, [sp(%$out_vector)]
		mov			r2, 18/6
		mov			r5, r1
		add			r5, fsizen(60)

		align 32
.lp_outer:

;0
		pmov		mm6, [r3+fsizen(0)]

		pmov		mm0, [r1+fsizen(0)]
		pmov		mm1, [r1+fsizen(2)]
		pmov		mm2, [r1+fsizen(4)]

		pfmul		mm0, mm6
		pmov		mm5, [r3+fsizen(4)]
		pfmul		mm1, mm6
		pmov		mm3, [r1+fsizen(0)+fsizen(20)]
		pfmul		mm2, mm6
;1
		pmov		mm4, [r1+fsizen(2)+fsizen(20)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(8)]
		pfmul		mm4, mm5
		pfadd		mm0, mm3
		pfmul		mm5, [r1+fsizen(4)+fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)-fsizen(20)]
		pfadd		mm2, mm5
;2
		pmov		mm4, [r5+fsizen(2)-fsizen(20)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(12)]
		pfmul		mm4, mm6
		pfadd		mm0, mm3
		pfmul		mm6, [r5+fsizen(4)-fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)]
		pfadd		mm2, mm6
;3
		pmov		mm4, [r5+fsizen(2)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(16)]
		pfmul		mm4, mm5
		add			r1, fsizen(120)
		pfadd		mm0, mm3
		pfmul		mm5, [r5+fsizen(4)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)+fsizen(20)]
		pfadd		mm2, mm5
;4
		pmov		mm4, [r5+fsizen(2)+fsizen(20)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(20)]
		pfmul		mm4, mm6
		pfadd		mm0, mm3
		pfmul		mm6, [r5+fsizen(4)+fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)-fsizen(20)]
		pfadd		mm2, mm6
;5
		pmov		mm4, [r1+fsizen(2)-fsizen(20)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(24)]
		pfmul		mm4, mm5
		add			r5, fsizen(120)
		pfadd		mm0, mm3
		pfmul		mm5, [r1+fsizen(4)-fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)]
		pfadd		mm2, mm5
;6
		pmov		mm4, [r1+fsizen(2)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(28)]
		pfmul		mm4, mm6
		add			r3, fsizen(64)
		pfadd		mm0, mm3
		pfmul		mm6, [r1+fsizen(4)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)+fsizen(20)]
		pfadd		mm2, mm6
;7
		pmov		mm4, [r1+fsizen(2)+fsizen(20)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(0)-fsizen(32)]
		pfmul		mm4, mm5
		pfadd		mm0, mm3
		pfmul		mm5, [r1+fsizen(4)+fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)-fsizen(20)]
		pfadd		mm2, mm5
;8
		pmov		mm4, [r5+fsizen(2)-fsizen(20)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(4)-fsizen(32)]
		pfmul		mm4, mm6
		pfadd		mm0, mm3
		pfmul		mm6, [r5+fsizen(4)-fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)]
		pfadd		mm2, mm6
;9
		pmov		mm4, [r5+fsizen(2)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(8)-fsizen(32)]
		pfmul		mm4, mm5
		add			r1, fsizen(120)
		pfadd		mm0, mm3
		pfmul		mm5, [r5+fsizen(4)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)+fsizen(20)]
		pfadd		mm2, mm5
;10
		pmov		mm4, [r5+fsizen(2)+fsizen(20)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(12)-fsizen(32)]
		pfmul		mm4, mm6
		pfadd		mm0, mm3
		pfmul		mm6, [r5+fsizen(4)+fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)-fsizen(20)]
		pfadd		mm2, mm6
;11
		pmov		mm4, [r1+fsizen(2)-fsizen(20)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(16)-fsizen(32)]
		pfmul		mm4, mm5
		pfadd		mm0, mm3
		pfmul		mm5, [r1+fsizen(4)-fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)]
		pfadd		mm2, mm5
;12
		pmov		mm4, [r1+fsizen(2)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(20)-fsizen(32)]
		pfmul		mm4, mm6
		add			r5, fsizen(120)
		pfadd		mm0, mm3
		pfmul		mm6, [r1+fsizen(4)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)+fsizen(20)]
		pfadd		mm2, mm6
;13
		pmov		mm4, [r1+fsizen(2)+fsizen(20)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(24)-fsizen(32)]
		pfmul		mm4, mm5
		pfadd		mm0, mm3
		pfmul		mm5, [r1+fsizen(4)+fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)-fsizen(20)]
		pfadd		mm2, mm5
;14
		pmov		mm4, [r5+fsizen(2)-fsizen(20)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(28)-fsizen(32)]
		pfmul		mm4, mm6
		pfadd		mm0, mm3
		pfmul		mm6, [r5+fsizen(4)-fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)]
		pfadd		mm2, mm6
;15
		pmov		mm4, [r5+fsizen(2)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(0)]
		pfmul		mm4, mm5
		add			r1, fsizen(120)
		pfadd		mm0, mm3
		pfmul		mm5, [r5+fsizen(4)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)+fsizen(20)]
		pfadd		mm2, mm5
;16
		pmov		mm4, [r5+fsizen(2)+fsizen(20)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(4)]
		pfmul		mm4, mm6
		pfadd		mm0, mm3
		pfmul		mm6, [r5+fsizen(4)+fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)-fsizen(20)]
		pfadd		mm2, mm6
;17
		pmov		mm4, [r1+fsizen(2)-fsizen(20)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(8)]
		pfmul		mm4, mm5
		pfadd		mm0, mm3
		pfmul		mm5, [r1+fsizen(4)-fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)]
		pfadd		mm2, mm5
;18
		pmov		mm4, [r1+fsizen(2)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(12)]
		pfmul		mm4, mm6
		add			r5, fsizen(120)
		pfadd		mm0, mm3
		pfmul		mm6, [r1+fsizen(4)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)+fsizen(20)]
		pfadd		mm2, mm6
;19
		pmov		mm4, [r1+fsizen(2)+fsizen(20)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(16)]
		pfmul		mm4, mm5
		pfadd		mm0, mm3
		pfmul		mm5, [r1+fsizen(4)+fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)-fsizen(20)]
		pfadd		mm2, mm5
;20
		pmov		mm4, [r5+fsizen(2)-fsizen(20)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(20)]
		pfmul		mm4, mm6
		pfadd		mm0, mm3
		pfmul		mm6, [r5+fsizen(4)-fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)]
		pfadd		mm2, mm6
;21
		pmov		mm4, [r5+fsizen(2)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(24)]
		pfmul		mm4, mm5
		add			r1, fsizen(120)
		pfadd		mm0, mm3
		pfmul		mm5, [r5+fsizen(4)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)+fsizen(20)]
		pfadd		mm2, mm5
;22
		pmov		mm4, [r5+fsizen(2)+fsizen(20)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(28)]
		pfmul		mm4, mm6
		add			r3, fsizen(64)
		pfadd		mm0, mm3
		pfmul		mm6, [r5+fsizen(4)+fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)-fsizen(20)]
		pfadd		mm2, mm6
;23
		pmov		mm4, [r1+fsizen(2)-fsizen(20)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(0)-fsizen(32)]
		pfmul		mm4, mm5
		pfadd		mm0, mm3
		pfmul		mm5, [r1+fsizen(4)-fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)]
		pfadd		mm2, mm5
;24
		pmov		mm4, [r1+fsizen(2)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(4)-fsizen(32)]
		pfmul		mm4, mm6
		add			r5, fsizen(120)
		pfadd		mm0, mm3
		pfmul		mm6, [r1+fsizen(4)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)+fsizen(20)]
		pfadd		mm2, mm6
;25
		pmov		mm4, [r1+fsizen(2)+fsizen(20)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(8)-fsizen(32)]
		pfmul		mm4, mm5
		pfadd		mm0, mm3
		pfmul		mm5, [r1+fsizen(4)+fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)-fsizen(20)]
		pfadd		mm2, mm5
;26
		pmov		mm4, [r5+fsizen(2)-fsizen(20)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(12)-fsizen(32)]
		pfmul		mm4, mm6
		pfadd		mm0, mm3
		pfmul		mm6, [r5+fsizen(4)-fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)]
		pfadd		mm2, mm6
;27
		pmov		mm4, [r5+fsizen(2)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(16)-fsizen(32)]
		pfmul		mm4, mm5
		add			r1, fsizen(120)
		pfadd		mm0, mm3
		pfmul		mm5, [r5+fsizen(4)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)+fsizen(20)]
		pfadd		mm2, mm5
;28
		pmov		mm4, [r5+fsizen(2)+fsizen(20)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(20)-fsizen(32)]
		pfmul		mm4, mm6
		pfadd		mm0, mm3
		pfmul		mm6, [r5+fsizen(4)+fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)-fsizen(20)]
		pfadd		mm2, mm6
;29
		pmov		mm4, [r1+fsizen(2)-fsizen(20)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(24)-fsizen(32)]
		pfmul		mm4, mm5
		pfadd		mm0, mm3
		pfmul		mm5, [r1+fsizen(4)-fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)]
		pfadd		mm2, mm5
;30
		pmov		mm4, [r1+fsizen(2)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(28)-fsizen(32)]
		pfmul		mm4, mm6
		add			r5, fsizen(120)
		pfadd		mm0, mm3
		pfmul		mm6, [r1+fsizen(4)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)+fsizen(20)]
		pfadd		mm2, mm6
;31
		pmov		mm4, [r1+fsizen(2)+fsizen(20)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(0)]
		pfmul		mm4, mm5
		pfadd		mm0, mm3
		pfmul		mm5, [r1+fsizen(4)+fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)-fsizen(20)]
		pfadd		mm2, mm5
;32
		pmov		mm4, [r5+fsizen(2)-fsizen(20)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(4)]
		pfmul		mm4, mm6
		pfadd		mm0, mm3
		pfmul		mm6, [r5+fsizen(4)-fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)]
		pfadd		mm2, mm6
;33
		pmov		mm4, [r5+fsizen(2)]
		pfmul		mm3, mm5
		pmov		mm6, [r3+fsizen(8)]
		pfmul		mm4, mm5
		add			r1, fsizen(120)
		pfadd		mm0, mm3
		pfmul		mm5, [r5+fsizen(4)]
		pfadd		mm1, mm4
		pmov		mm3, [r5+fsizen(0)+fsizen(20)]
		pfadd		mm2, mm5
;34
		pmov		mm4, [r5+fsizen(2)+fsizen(20)]
		pfmul		mm3, mm6
		pmov		mm5, [r3+fsizen(12)]
		pfmul		mm4, mm6
		pfadd		mm0, mm3
		pfmul		mm6, [r5+fsizen(4)+fsizen(20)]
		pfadd		mm1, mm4
		pmov		mm3, [r1+fsizen(0)-fsizen(20)]
		pfadd		mm2, mm6
;35
		pmov		mm4, [r1+fsizen(2)-fsizen(20)]
		pfmul		mm3, mm5
		add			r0, fsizen(6)
		pfmul		mm4, mm5
		pfadd		mm0, mm3
		pfmul		mm5, [r1+fsizen(4)-fsizen(20)]
		sub			r3, fsizen(64*2)
		pfadd		mm1, mm4
		sub			r5, fsizen(120*5-6)
		pmov		[r0-fsizen(6)], mm0
		sub			r1, fsizen(120*6-6)
		pfadd		mm2, mm5
		pmov		[r0-fsizen(4)], mm1

		dec			r2
		pmov		[r0-fsizen(2)], mm2
		jnz	near	.lp_outer

		dec			dword [sp(%$count)]
		jnz	near	.lp_count

		femms
		popd	ebp, edi, esi, ebx
endproc

;***************************************************************

proc	entry_3DN_SOA_OoO_K6

		%$coeff			arg		4
		%$in_vector		arg		4
		%$out_vector	arg		4
		%$count			arg		4

		femms
		pushd	ebp, edi, esi, ebx

		mov			r4, [sp(%$count)]

		align 32
.lp_count:
		mov			r3, [sp(%$in_vector)]
		mov			r1, [sp(%$coeff)]
		mov			r0, [sp(%$out_vector)]
		mov			r2, fsizen(64)
		mov			r5, fsizen(60)
		add			r2, r3
		add			r5, r1

%macro muladd061 5
		pmov		mm5, [%1+%2*fsizen(4)+fsizen(32)*(%3)]

		pmov		mm6, [%4+fsizen(0)+fsizen(20)*(%5)]
		pmov		mm7, [%4+fsizen(2)+fsizen(20)*(%5)]
		pfmul		mm6, mm5
		pfmul		mm7, mm5
		pfadd		mm0, mm6
		pfadd		mm1, mm7

		pmov		mm6, [%4+fsizen(4)+fsizen(20)*(%5)]
		pmov		mm7, [%4+fsizen(6)+fsizen(20)*(%5)]
		pfmul		mm6, mm5
		pfmul		mm7, mm5
		pfmul		mm5, [%4+fsizen(8)+fsizen(20)*(%5)]
		pfadd		mm2, mm6		
		pfadd		mm3, mm7
		pfadd		mm4, mm5
%endmacro

		pmov		mm4, [r3+fsizen(0)]

		pmov		mm0, [r1+fsizen(0)]
		pmov		mm1, [r1+fsizen(2)]
		pfmul		mm0, mm4
		pfmul		mm1, mm4

		pmov		mm2, [r1+fsizen(4)]
		pmov		mm3, [r1+fsizen(6)]
		pfmul		mm2, mm4
		pfmul		mm3, mm4
		pfmul		mm4, [r1+fsizen(8)]


		muladd061	r3, 1, (0), r1, (1)
		add			r1, fsizen(120)
		muladd061	r3, 2, (0), r5, (-1)
		muladd061	r3, 3, (0), r5, (0)
		muladd061	r3, 4, (0), r5, (1)
		add			r5, fsizen(120)
		muladd061	r3, 5, (0), r1, (-1)
		muladd061	r3, 6, (0), r1, (0)
		muladd061	r3, 7, (0), r1, (1)
		add			r3, fsizen(128)
		add			r1, fsizen(120)
		muladd061	r2, 0, (-1), r5, (-1)
		muladd061	r2, 1, (-1), r5, (0)
		muladd061	r2, 2, (-1), r5, (1)
		add			r5, fsizen(120)
		muladd061	r2, 3, (-1), r1, (-1)
		muladd061	r2, 4, (-1), r1, (0)
		muladd061	r2, 5, (-1), r1, (1)
		add			r1, fsizen(120)
		muladd061	r2, 6, (-1), r5, (-1)
		muladd061	r2, 7, (-1), r5, (0)
		muladd061	r2, 0, (0), r5, (1)
		add			r5, fsizen(120)
		muladd061	r2, 1, (0), r1, (-1)
		muladd061	r2, 2, (0), r1, (0)
		muladd061	r2, 3, (0), r1, (1)
		add			r1, fsizen(120)
		muladd061	r2, 4, (0), r5, (-1)
		muladd061	r2, 5, (0), r5, (0)
		muladd061	r2, 6, (0), r5, (1)
		add			r5, fsizen(120)
		muladd061	r2, 7, (0), r1, (-1)
		muladd061	r3, 0, (-1), r1, (0)
		muladd061	r3, 1, (-1), r1, (1)
		add			r1, fsizen(120)
		muladd061	r3, 2, (-1), r5, (-1)
		muladd061	r3, 3, (-1), r5, (0)
		muladd061	r3, 4, (-1), r5, (1)
		add			r5, fsizen(120)
		muladd061	r3, 5, (-1), r1, (-1)
		muladd061	r3, 6, (-1), r1, (0)
		muladd061	r3, 7, (-1), r1, (1)
		add			r1, fsizen(120)
		muladd061	r3, 0, (0), r5, (-1)
		muladd061	r3, 1, (0), r5, (0)
		muladd061	r3, 2, (0), r5, (1)
		muladd061	r3, 3, (0), r1, (-1)
		pmov		[r0+fsizen(0)], mm0
		sub			r3, fsizen(128)
		pmov		[r0+fsizen(2)], mm1
		sub			r1, fsizen(120*6-10)
		pmov		[r0+fsizen(4)], mm2
		sub			r5, fsizen(120*5-10)
		pmov		[r0+fsizen(6)], mm3
		pmov		[r0+fsizen(8)], mm4
		add			r0, fsizen(10)

%macro muladd062 5
		pmov		mm4, [%1+%2*fsizen(4)+fsizen(32)*(%3)]

		pmov		mm5, [%4+fsizen(0)+fsizen(20)*(%5)]
		pmov		mm6, [%4+fsizen(2)+fsizen(20)*(%5)]
		pmov		mm7, [%4+fsizen(4)+fsizen(20)*(%5)]

		pfmul		mm5, mm4
		pfmul		mm6, mm4
		pfmul		mm7, mm4
		pfmul		mm4, [%4+fsizen(6)+fsizen(20)*(%5)]

		pfadd		mm0, mm5
		pfadd		mm1, mm6
		pfadd		mm2, mm7
		pfadd		mm3, mm4
%endmacro

		pmov		mm3, [r3+fsizen(0)]

		pmov		mm0, [r1+fsizen(0)]
		pmov		mm1, [r1+fsizen(2)]
		pmov		mm2, [r1+fsizen(4)]
		pfmul		mm0, mm3
		pfmul		mm1, mm3
		pfmul		mm2, mm3
		pfmul		mm3, [r1+fsizen(6)]


		muladd062	r3, 1, (0), r1, (1)
		add			r1, fsizen(120)
		muladd062	r3, 2, (0), r5, (-1)
		muladd062	r3, 3, (0), r5, (0)
		muladd062	r3, 4, (0), r5, (1)
		add			r5, fsizen(120)
		muladd062	r3, 5, (0), r1, (-1)
		muladd062	r3, 6, (0), r1, (0)
		muladd062	r3, 7, (0), r1, (1)
		add			r3, fsizen(128)
		add			r1, fsizen(120)
		muladd062	r2, 0, (-1), r5, (-1)
		muladd062	r2, 1, (-1), r5, (0)
		muladd062	r2, 2, (-1), r5, (1)
		add			r5, fsizen(120)
		muladd062	r2, 3, (-1), r1, (-1)
		muladd062	r2, 4, (-1), r1, (0)
		muladd062	r2, 5, (-1), r1, (1)
		add			r1, fsizen(120)
		muladd062	r2, 6, (-1), r5, (-1)
		muladd062	r2, 7, (-1), r5, (0)
		muladd062	r2, 0, (0), r5, (1)
		add			r5, fsizen(120)
		muladd062	r2, 1, (0), r1, (-1)
		muladd062	r2, 2, (0), r1, (0)
		muladd062	r2, 3, (0), r1, (1)
		add			r1, fsizen(120)
		muladd062	r2, 4, (0), r5, (-1)
		muladd062	r2, 5, (0), r5, (0)
		muladd062	r2, 6, (0), r5, (1)
		add			r5, fsizen(120)
		muladd062	r2, 7, (0), r1, (-1)
		muladd062	r3, 0, (-1), r1, (0)
		muladd062	r3, 1, (-1), r1, (1)
		add			r1, fsizen(120)
		muladd062	r3, 2, (-1), r5, (-1)
		muladd062	r3, 3, (-1), r5, (0)
		muladd062	r3, 4, (-1), r5, (1)
		add			r5, fsizen(120)
		muladd062	r3, 5, (-1), r1, (-1)
		muladd062	r3, 6, (-1), r1, (0)
		muladd062	r3, 7, (-1), r1, (1)
		add			r1, fsizen(120)
		muladd062	r3, 0, (0), r5, (-1)
		muladd062	r3, 1, (0), r5, (0)
		muladd062	r3, 2, (0), r5, (1)
		muladd062	r3, 3, (0), r1, (-1)

		dec			r4
		pmov		[r0+fsizen(0)], mm0
		pmov		[r0+fsizen(2)], mm1
		pmov		[r0+fsizen(4)], mm2
		pmov		[r0+fsizen(6)], mm3

		jnz	near	.lp_count

		femms
		popd	ebp, edi, esi, ebx
endproc

;***************************************************************

proc	entry_3DN_SOA_OoO_K7

		%$coeff			arg		4
		%$in_vector		arg		4
		%$out_vector	arg		4
		%$count			arg		4

		femms
		pushd	ebp, edi, esi, ebx

		mov		r4, [sp(%$count)]

		align 32
.lp_count:
		mov		r3, [sp(%$in_vector)]
		mov		r1, [sp(%$coeff)]
		mov		r0, [sp(%$out_vector)]
		mov		r2, r3
		mov		r5, r1
		add		r2, fsizen(64)
		add		r5, fsizen(60)

%macro muladd 5
		pmov		mm5, [%1+%2*fsizen(4)+fsizen(32)*(%3)]
		pmov		mm6, [%4+fsizen(0)+fsizen(20)*(%5)]

		pfmul		mm6, mm5
		pmov		mm7, [%4+fsizen(2)+fsizen(20)*(%5)]
		pfadd		mm0, mm6

		pfmul		mm7, mm5
		pmov		mm6, [%4+fsizen(4)+fsizen(20)*(%5)]
		pfadd		mm1, mm7
		
		pfmul		mm6, mm5
		pmov		mm7, [%4+fsizen(6)+fsizen(20)*(%5)]
		pfadd		mm2, mm6

		pfmul		mm7, mm5
		pfadd		mm3, mm7

		pfmul		mm5, [%4+fsizen(8)+fsizen(20)*(%5)]
		pfadd		mm4, mm5
%endmacro

		pmov		mm4, [r3+fsizen(4)]

		pmov		mm0, [r1+fsizen(0)]
		pfmul		mm0, mm4

		pmov		mm1, [r1+fsizen(2)]
		pfmul		mm1, mm4

		pmov		mm2, [r1+fsizen(4)]
		pfmul		mm2, mm4

		pmov		mm3, [r1+fsizen(6)]
		pfmul		mm3, mm4

		pfmul		mm4, [r1+fsizen(8)]


		muladd		r3, 1, (0), r1, (1)
		add			r1, fsizen(120)
		muladd		r3, 2, (0), r5, (-1)
		muladd		r3, 3, (0), r5, (0)
		muladd		r3, 4, (0), r5, (1)
		add			r5, fsizen(120)
		muladd		r3, 5, (0), r1, (-1)
		muladd		r3, 6, (0), r1, (0)
		muladd		r3, 7, (0), r1, (1)
		add			r3, fsizen(128)
		add			r1, fsizen(120)
		muladd		r2, 0, (-1), r5, (-1)
		muladd		r2, 1, (-1), r5, (0)
		muladd		r2, 2, (-1), r5, (1)
		add			r5, fsizen(120)
		muladd		r2, 3, (-1), r1, (-1)
		muladd		r2, 4, (-1), r1, (0)
		muladd		r2, 5, (-1), r1, (1)
		add			r1, fsizen(120)
		muladd		r2, 6, (-1), r5, (-1)
		muladd		r2, 7, (-1), r5, (0)
		muladd		r2, 0, (0), r5, (1)
		add			r5, fsizen(120)
		muladd		r2, 1, (0), r1, (-1)
		muladd		r2, 2, (0), r1, (0)
		muladd		r2, 3, (0), r1, (1)
		add			r1, fsizen(120)
		muladd		r2, 4, (0), r5, (-1)
		muladd		r2, 5, (0), r5, (0)
		muladd		r2, 6, (0), r5, (1)
		add			r5, fsizen(120)
		muladd		r2, 7, (0), r1, (-1)
		muladd		r3, 0, (-1), r1, (0)
		muladd		r3, 1, (-1), r1, (1)
		add			r1, fsizen(120)
		muladd		r3, 2, (-1), r5, (-1)
		muladd		r3, 3, (-1), r5, (0)
		muladd		r3, 4, (-1), r5, (1)
		add			r5, fsizen(120)
		muladd		r3, 5, (-1), r1, (-1)
		muladd		r3, 6, (-1), r1, (0)
		muladd		r3, 7, (-1), r1, (1)
		add			r1, fsizen(120)
		muladd		r3, 0, (0), r5, (-1)
		muladd		r3, 1, (0), r5, (0)
		muladd		r3, 2, (0), r5, (1)
		muladd		r3, 3, (0), r1, (-1)
		
		pmov		[r0+fsizen(0)], mm0
		sub			r3, fsizen(128)
		pmov		[r0+fsizen(2)], mm1
		sub			r1, fsizen(120*6-10)
		pmov		[r0+fsizen(4)], mm2
		sub			r5, fsizen(120*5-10)
		pmov		[r0+fsizen(6)], mm3
		pmov		[r0+fsizen(8)], mm4
		add			r0, fsizen(10)

%macro muladd2 5
		pmov		mm4, [%1+%2*fsizen(4)+fsizen(32)*(%3)]
		pmov		mm5, [%4+fsizen(0)+fsizen(20)*(%5)]
		
		pfmul		mm5, mm4
		pmov		mm6, [%4+fsizen(2)+fsizen(20)*(%5)]
		pfadd		mm0, mm5
		
		pfmul		mm6, mm4
		pmov		mm7, [%4+fsizen(4)+fsizen(20)*(%5)]
		pfadd		mm1, mm6
		
		pfmul		mm7, mm4
		pfadd		mm2, mm7
		
		pfmul		mm4, [%4+fsizen(6)+fsizen(20)*(%5)]
		pfadd		mm3, mm4
%endmacro

		pmov		mm3, [r3+fsizen(4)]

		pmov		mm0, [r1+fsizen(0)]
		pfmul		mm0, mm3

		pmov		mm1, [r1+fsizen(2)]
		pfmul		mm1, mm3

		pmov		mm2, [r1+fsizen(4)]
		pfmul		mm2, mm3

		pfmul		mm3, [r1+fsizen(6)]


		muladd2		r3, 1, (0), r1, (1)
		add			r1, fsizen(120)
		muladd2		r3, 2, (0), r5, (-1)
		muladd2		r3, 3, (0), r5, (0)
		muladd2		r3, 4, (0), r5, (1)
		add			r5, fsizen(120)
		muladd2		r3, 5, (0), r1, (-1)
		muladd2		r3, 6, (0), r1, (0)
		muladd2		r3, 7, (0), r1, (1)
		add			r3, fsizen(128)
		add			r1, fsizen(120)
		muladd2		r2, 0, (-1), r5, (-1)
		muladd2		r2, 1, (-1), r5, (0)
		muladd2		r2, 2, (-1), r5, (1)
		add			r5, fsizen(120)
		muladd2		r2, 3, (-1), r1, (-1)
		muladd2		r2, 4, (-1), r1, (0)
		muladd2		r2, 5, (-1), r1, (1)
		add			r1, fsizen(120)
		muladd2		r2, 6, (-1), r5, (-1)
		muladd2		r2, 7, (-1), r5, (0)
		muladd2		r2, 0, (0), r5, (1)
		add			r5, fsizen(120)
		muladd2		r2, 1, (0), r1, (-1)
		muladd2		r2, 2, (0), r1, (0)
		muladd2		r2, 3, (0), r1, (1)
		add			r1, fsizen(120)
		muladd2		r2, 4, (0), r5, (-1)
		muladd2		r2, 5, (0), r5, (0)
		muladd2		r2, 6, (0), r5, (1)
		add			r5, fsizen(120)
		muladd2		r2, 7, (0), r1, (-1)
		muladd2		r3, 0, (-1), r1, (0)
		muladd2		r3, 1, (-1), r1, (1)
		add			r1, fsizen(120)
		muladd2		r3, 2, (-1), r5, (-1)
		muladd2		r3, 3, (-1), r5, (0)
		muladd2		r3, 4, (-1), r5, (1)
		add			r5, fsizen(120)
		muladd2		r3, 5, (-1), r1, (-1)
		muladd2		r3, 6, (-1), r1, (0)
		muladd2		r3, 7, (-1), r1, (1)
		add			r1, fsizen(120)
		muladd2		r3, 0, (0), r5, (-1)
		muladd2		r3, 1, (0), r5, (0)
		muladd2		r3, 2, (0), r5, (1)
		muladd2		r3, 3, (0), r1, (-1)

		dec			r4
		pmov		[r0+fsizen(0)], mm0
		pmov		[r0+fsizen(2)], mm1
		pmov		[r0+fsizen(4)], mm2
		pmov		[r0+fsizen(6)], mm3

		jnz	near	.lp_count

		femms
		popd	ebp, edi, esi, ebx
endproc

;***************************************************************

