
%include "nasm.h"

%idefine fixfloat word
%idefine fixfsize 2
%idefine fixfsizen(a) (fixfsize*(a))

[segment_data]

	align 32
coeff		times 20*36	dw 0
in_vector	times 36*4	dw 0
out_vector	times 20	dw 0

	align 32
D_32768@0	dd 32768.0		;1<<15				-1<=in_vector<1
D_1024@0	dd 1024.0		;1<<10				-64<=coeff<64
D_D512@0	dd 0.001953125	;1/512.0 = 1>>9		-128<=t<128

[segment_code]

;***************************************************************

proc	entry_16bitfixed_MMX

		%$coeff			arg		4
		%$in_vector		arg		4
		%$out_vector	arg		4
		%$count			arg		4

		pushd	ebp, edi, esi, ebx

;init0
		mov		r0, [sp(%$in_vector)]
		mov		r1, in_vector
		xor		r2, r2
		fld		dword [D_32768@0]
.in_lp0:
		fld		dword [r0+r2*4]
		fmul	st0, st1
		fistp	word [r1+r2*2]
		inc		r2
		cmp		r2, 36
		jb		.in_lp0
		fstp	st0

;init1
		mov		r0, [sp(%$coeff)]
		mov		r1, coeff
		xor		r2, r2
		fld		dword [D_1024@0]
.in_lp1:
		fld		dword [r0+r2*4]
		fmul	st0, st1
		fistp	word [r1+r2*2]
		inc		r2
		cmp		r2, 36*18
		jb		.in_lp1
		fstp	st0

;mainloop
		mov		r4, [sp(%$count)]
		pxor	mm7, mm7
		mov		r0, in_vector
		jmp		.loop
		align 16
.loop
		mov		r1, coeff+64
		mov		r2, out_vector
.lp0:
		xor		r3, r3
		pmov	mm0, mm7
		pmov	mm1, mm7
		pmov	mm2, mm7
.lp1:
		pmov	mm5, [r0+r3]
		pmov	mm3, [r1+r3+fixfsizen(36*0)-64]
		pmov	mm4, [r1+r3+fixfsizen(36*1)-64]
		pmulhw	mm3, mm5
		pmulhw	mm4, mm5
		pmulhw	mm5, [r1+r3+fixfsizen(36*2)-64]
		paddw	mm0, mm3
		paddw	mm1, mm4
		paddw	mm2, mm5

		add		r3, fixfsizen(4)
		cmp		r3, fixfsizen(36)
		jb		.lp1

		pmov	mm3, mm0		;3 | 2 | 1 | 0
		pmov	mm4, mm1
		puphwd	mm0, mm2		;  | 3 |   | 2
		puphwd	mm1, mm7
		puplwd	mm3, mm2		;  | 1 |   | 0
		puplwd	mm4, mm7
		paddw	mm0, mm3
		paddw	mm1, mm4

		pmov	mm2, mm0		;  | 1 |   | 0
		pmov	mm3, mm1
		puphwd	mm0, mm7		;  |   |   | 1
		puphdq	mm1, mm7
		puplwd	mm2, mm7		;  |   |   | 0
		pupldq	mm3, mm7
		paddw	mm0, mm2
		paddw	mm1, mm3

		pmov	mm2, mm0
		puplwd	mm0, mm1
		puphdq	mm2, mm2

		pmovd	[r2], mm0
		pmovd	[r2+4], mm2
		add		r2, fixfsizen(3)

		add		r1, fixfsizen(36)*3
		cmp		r1, coeff+64+fixfsizen(36)*18
		jb near .lp0

		dec		r4
		jnz near .loop

;term
		emms
		mov		r0, out_vector
		mov		r1, [sp(%$out_vector)]
		xor		r2, r2
		fld		dword [D_D512@0]
.tr_lp0:
		fild	word [r0+r2*2]
		fmul	st0, st1
		fstp	dword [r1+r2*4]
		inc		r2
		cmp		r2, 18
		jb		.tr_lp0
		fstp	st0

		popd	ebp, edi, esi, ebx
endproc

;***************************************************************

proc	entry_16bitfixed_MMX_SOA

		%$coeff			arg		4
		%$in_vector		arg		4
		%$out_vector	arg		4
		%$count			arg		4

		pushd	ebp, edi, esi, ebx

;init0
		mov		r0, [sp(%$in_vector)]
		mov		r1, in_vector
		xor		r2, r2
		fld		dword [D_32768@0]
.in_lp0:
		fld		dword [r0+r2*4]
		fmul	st0, st1
		fistp	word [r1+r2*2]
		inc		r2
		cmp		r2, 36*4
		jb		.in_lp0
		fstp	st0

;init1
		mov		r0, [sp(%$coeff)]
		mov		r1, coeff
		xor		r2, r2
		fld		dword [D_1024@0]
.in_lp1:
		fld		dword [r0+r2*4]
		fmul	st0, st1
		fistp	word [r1+r2*2]
		inc		r2
		cmp		r2, 20*36
		jb		.in_lp1
		fstp	st0

;mainloop
		mov		r4, [sp(%$count)]
		mov		r2, out_vector
		jmp		.loop
		align 16
.loop:
		mov		r0, in_vector
		mov		r1, coeff
		pxor	mm0, mm0
		pxor	mm1, mm1
		pxor	mm2, mm2
		pxor	mm3, mm3
		pxor	mm4, mm4
		jmp		.lp0
		align 16
.lp0:
		pmov	mm5, [r0]
		pmov	mm6, [r1+fixfsizen(0)]
		pmov	mm7, [r1+fixfsizen(4)]
		pmulhw	mm6, mm5
		pmulhw	mm7, mm5
		paddw	mm0, mm6
		paddw	mm1, mm7

		pmov	mm6, [r1+fixfsizen(8)]
		pmov	mm7, [r1+fixfsizen(12)]
		pmulhw	mm6, mm5
		pmulhw	mm7, mm5
		pmulhw	mm5, [r1+fixfsizen(16)]
		paddw	mm2, mm6
		paddw	mm3, mm7
		paddw	mm4, mm5

		add		r1, fixfsizen(20)
		add		r0, fixfsizen(4)
		cmp		r0, in_vector+fixfsizen(4)*36
		jb		.lp0

		pmov	[r2+fixfsizen( 0)], mm0
		pmov	[r2+fixfsizen( 4)], mm1
		pmov	[r2+fixfsizen( 8)], mm2
		pmov	[r2+fixfsizen(12)], mm3
		pmov	[r2+fixfsizen(16)], mm4

		dec		r4
		jnz near .loop

;term
		emms
		mov		r0, out_vector
		mov		r1, [sp(%$out_vector)]
		xor		r2, r2
		fld		dword [D_D512@0]
.tr_lp0:
		fild	word [r0+r2*2]
		fmul	st0, st1
		fstp	dword [r1+r2*4]
		inc		r2
		cmp		r2, 18
		jb		.tr_lp0
		fstp	st0

		popd	ebp, edi, esi, ebx
endproc

